# Lionsnet - IP/Subnetting Calculator

> Lionsnet - A VPC provisioning and subnetting calculator
> powered by AWS Lambda and DynamoDB.


### Features

&nbsp; &nbsp; ✓ Size and Provision new AWS VPCs<br>
&nbsp; &nbsp; ✓ Properly subnet your VPCs while reducing IP Address fragmentation<br>
&nbsp; &nbsp; ✓ Release IP Address ranges that aren't in use<br>

### Documentation

* [Getting Started](docs/getting-started.md)
* [Getting Started](docs/getting-started.md)
* [Creating a VPC](docs/recipes/create-vpc.md)
* [Deleting a VPC](docs/recipes/delete-vpc.md)
* [Creating Subnets within a VPC](docs/recipes/create-subnet.md)
* [Deleting Subnets within a VPC](docs/recipes/delete-subnet.md)


## Roadmap
[Lionsnet Trello Board](https://trello.com/b/wK7ZjMqg/lionsnet)


### Get in Touch

* [@realMIglesias](https://twitter.com/realMIglesias)


### License

Copyright © 2015-2016 Michael Iglesias. This source code is licensed under the CC BY-SA 4.0 license found in
the [LICENSE.txt](https://github.com/Lionshead-io/lionsnet-subnetting-calculator-serverless-aws/blob/master/LICENSE.txt) file.
The documentation to the project is licensed under the [CC BY-SA 4.0](http://creativecommons.org/licenses/by-sa/4.0/)
license.


---
Made with ♥ by Michael Iglesias (Lionshead Consulting Group) ([@realMIglesias](https://twitter.com/realMIglesias)) and [contributors](https://github.com/Lionshead-io/lionsnet-subnetting-calculator-serverless-aws/graphs/contributors)
